#ifndef _CALC_H
#define _CALC_H

#include "matrix.h"
#include "tree.h"

#define ref_weight(a, i, afn)	\
  if ((i) != 0) \
  v_add_multiple(a, - v_entry(a, i - 1), afn->cartan_rows[i - 1]); \
  else \
  v_add_multiple(a, (afn)->p - v_dot((afn)->high_pair, a), (afn)->high_weight)

void apply_to_alcove(vector *a, list *s, affine *afn);
void calc_alcove(vector *a, list *s, affine *afn);
int weight_to_exp(list *exp, vector *weight, vector *res, affine *afn);
void alcove_to_exp(list *exp, vector *alc, affine *afn);
void reduced_exp(list *exp, list *s, affine *afn);

#define TB_ALL		0
#define TB_DOMINANT	1
#define TB_RESTRICTED	2

treebase *build_tree(list *s, int filter, affine *afn);
void tb_add_element(treebase *tb, list *s, int filter);
void calc_bit_matrices(treebase *tb);

int node_lesseq(node *nd1, node *nd2, treebase *tb);
int bruhat_lesseq(list *exp1, list *exp2, treebase *tb);

#endif
