/*  Dynkin project programs
 *  Copyright (C) 1998 Anders S. Buch (abuch@mi.aau.dk)
 *  See the file LICENSE for license information.
 */

#include <stdio.h>

#include "list.h"
#include "efstring.h"
#include "output.h"
#include "calc.h"

void pvec(vector *v)
{ print_vec(v, 0); }

void pmat(matrix *m)
{ print_mat(m); }

void ppoly(polynomial *p)
{ print_poly(p); }

void plist(list *l)
{ print_intlist(l, 0); }

void palcexp(vector *a, treebase *tb)
{
  list *l = l_new();
  alcove_to_exp(l, a, tb_affine(tb));
  plist(l);
  l_free(l);
}

void pnodeexp(node *nd, treebase *tb)
{ palcexp(n_alcove(nd), tb); }

#if 0
void pefs(list *efs)
{ print_efstring(efs); }
#endif

void pws(weight_set *ws)
{ print_weight_set(ws, 2, 0); }

void pvl(list *vl)
{
  int i;
  for (i = 0; i < l_length(vl); i++)
    print_vec(l_element(vl, i), 0);
}

void pls(list *pi)
{ print_lspath(pi); }
