/*  Dynkin project programs
 *  Copyright (C) 1998 Anders S. Buch (abuch@mi.aau.dk)
 *  See the file LICENSE for license information.
 */

#include "alloc.h"
#include "output.h"
#include "affine.h"
#include "matrix.h"
#include "weight.h"
#include "freudlib.h"
#include "cmdline.h"


void print_usage(char *s)
{
  fprintf(stderr, "Usage: %s rsys weight\n", s);
  exit(1);
}

int main(int ac, char **av)
{
  weight_set *ws;
  vector *high_weight;
  int *action_tab;
  affine *afn;
  
  cmd_init(ac, av);
  afn = cmd_rsys();
  high_weight = cmd_weight(0, afn);
  
  action_tab = build_action_tab(afn);
  ws = freudenthal(high_weight, afn, action_tab);
  weyl_free(action_tab);
  
  print_weight_set(ws, 1, 0);
  
  afn_free(afn);
  v_free(high_weight);
  ws_free(ws);
  memory_report;
  
  exit(0);
}
