/*  Dynkin project programs
 *  Copyright (C) 1998 Anders S. Buch (abuch@mi.aau.dk)
 *  See the file LICENSE for license information.
 */

#include <stdio.h>
#include <stdlib.h>

#include "alloc.h"
#include "list.h"
#include "matrix.h"
#include "affine.h"
#include "output.h"
#include "calc.h"
#include "tree.h"
#include "cmdline.h"


void print_usage(char *s)
{
  fprintf(stderr, "Usage: %s wge1 - wge2\n", s);
  exit(1);
}

int main(int ac, char **av)
{
  list *s1, *s2; 
  treebase *tb;
  affine *afn;
  
  cmd_init(ac, av);
  afn = cmd_rsys();
  s1 = cmd_wge(afn);
  cmd_dash(1);
  s2 = cmd_wge(afn);
  
  tb = build_tree(s2, 0, afn);
  
  printf(tb_find(tb, s1) != NULL ? "YES\n\n" : "NO\n\n");
  
  tb_free(tb);
  l_free(s1);
  l_free(s2);
  
  memory_report;
  
  exit(0);
}
