#ifndef _LIST_H
#define _LIST_H

#include "claim.h"

typedef struct _list {
  int length;
  int array_size;
  void **array;
} list;

#define l_length(list)		((list)->length)
#define l_element(list, i)	((list)->array[i])

#define l_intelem(list, i)	(*((int *) ((list)->array + i)))
#define l_appendint(list, e)	(l_appendto(list, (void *) (e)))

#define l_reset(list)		((list)->length = 0)
#define l_remove_last(list)	((list)->array[--(list)->length])

list *l_new();
list *l_new_copy(list *src);
void l_free(list *list);

void l_copy(list *dst, list *src);
void l_appendto(list *list, void *e);
void l_reverse(list *list);
void l_remove_elem(list *list, int i);

int l_compare(list *lst1, list *lst2);

void free_veclist(list *list);

#endif
