#ifndef _OUTPUT_H
#define _OUTPUT_H

#include <stdio.h>

#include "matrix.h"
#include "affine.h"
#include "tree.h"
#include "polynomial.h"
#include "weight.h"

#define print_intlist(l,ind)	fprint_intlist(stdout, l, ind)
#define print_vec(v,indent)	fprint_vec(stdout, v, indent)
#define print_mat(m)		fprint_mat(stdout, m)
#define print_affine(a)		fprint_affine(stdout, a)
#define print_table(vl,m)	fprint_table(stdout, vl, m)
#define print_tree(tb,m)	fprint_tree(stdout, tb, m)
#define print_poly(p)		fprint_poly(stdout, p)
#define print_weight(w,add)	fprint_weight(stdout, w, add)
#define print_weight_set(om,pc,add) fprint_weight_set(stdout, om, pc, add)
#define print_vec_list(vl)	fprint_vec_list(stdout, vl)
#define print_lspath(pi)	fprint_lspath(stdout, pi)
#define print_efstring(efs)	fprint_efstring(stdout, efs)

void fprint_vec(FILE *s, vector *v, int indent);
void fprint_mat(FILE *s, matrix *m);
void fprint_affine(FILE *s, affine *affine);
void fprint_table(FILE *s, list *vec_list, matrix *m);
void fprint_poly(FILE *s, polynomial *p);
void fprint_intlist(FILE *s, list *l, int indent);
void fprint_nodes_below(FILE *s, treebase *tb, node *nd, int mode);

#define PTM_WEYL 0
#define PTM_WEIGHT 1
#define PTM_COORD 2
void fprint_tree(FILE *s, treebase *tb, int mode);

void fprint_weight(FILE *s, vector *w, int add);
void fprint_weight_set(FILE *s, weight_set *ws, int prtcoef, int add);
void fprint_vec_list(FILE *s, list *veclist);
void fprint_lspath(FILE *s, list *pi);
void fprint_efstring(FILE *s, list *efs);

#endif
