#ifndef _POLYNOMIAL_H
#define _POLYNOMIAL_H

typedef struct _polynomial {
  int coef_used;
  int coef_size;
  int *coef_list;
} polynomial;

#define p_coef_used(p)	((p)->coef_used)
#define p_coef_size(p)	((p)->coef_size)
#define p_coef_list(p)	((p)->coef_list)

#define p_degree(p)	((p)->coef_used - 1)
#define p_coef(p,i)	((p)->coef_list[i])

polynomial *p_new(int c);
void p_free(polynomial *p);
void p_set_const(polynomial *p, int c);
void p_copy(polynomial *dst, polynomial *p);

polynomial *p_new_size(int sz);
void p_extend(polynomial *p, int sz);

void p_add_multiple(polynomial *dst, polynomial *p, int r, int d);

/* void p_add(polynomial *dst, polynomial *p1, polynomial *p2); */
/* void p_mult(polynomial *dst, polynomial *p1, polynomial *p2); */
/* void p_mult_qplus1(polynomial *p); */
/* #define p_mult_qn(p, n)		(p_low_deg(p) += (n)) */
/* void p_scale(polynomial *p, int r); */

#endif
